1. 程式人生 > >LeetCode(46) Lowest Common Ancestor of a Binary (Search) Tree

LeetCode(46) Lowest Common Ancestor of a Binary (Search) Tree

Lowest Common Ancestor of a Binary Search Tree

題目描述

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

 Lowest Common Ancestor of a Binary Search Tree

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Lowest Common Ancestor of a Binary Tree

題目描述

Given a binary tree, find the lowest common ancestor (LCA) of two given nodes in the tree.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

Lowest Common Ancestor of a Binary Tree

For example, the lowest common ancestor (LCA) of nodes 5 and 1 is 3. Another example is LCA of nodes 5 and 4 is 5, since a node can be a descendant of itself according to the LCA definition.

題目解析

這裡一個通用的解法是判斷樹的左右子樹是否包含兩個元素,若兩元素分別分佈在左右子樹上,則公共祖先為當前結點,否則遞迴到當前結點的左(右)子樹。該方法思路簡單,但是問題也很明顯,效率不高,並且對於binary search tree而言沒有用上其性質,後續會更新效率更高的演算法。

/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    bool hasNode(TreeNode* node, TreeNode* p, TreeNode* q)
    {
        if(node == NULL) return false;
        if(node == p || node == q) return true;
        return hasNode(node->left, p, q) || hasNode(node->right, p, q);
    }
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        if(root == p || root == q) return root;

        bool left = hasNode(root->left, p, q);
        bool right = hasNode(root->right, p, q);
        if(left && right) return root;
        if(left) return lowestCommonAncestor(root->left, p, q);
        if(right) return lowestCommonAncestor(root->right, p, q);
    }
};